C. Posterized(Div.2)(并查集)

链接:http://codeforces.com/contest/980/problem/C

C. Posterized
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Professor Ibrahim has prepared the final homework for his algorithm’s class. He asked his students to implement the Posterization Image Filter.

Their algorithm will be tested on an array of integers, where the ii-th integer represents the color of the ii-th pixel in the image. The image is in black and white, therefore the color of each pixel will be an integer between 0 and 255 (inclusive).

To implement the filter, students are required to divide the black and white color range [0, 255] into groups of consecutive colors, and select one color in each group to be the group’s key. In order to preserve image details, the size of a group must not be greater than kk, and each color should belong to exactly one group.

Finally, the students will replace the color of each pixel in the array with that color’s assigned group key.

To better understand the effect, here is an image of a basking turtle where the Posterization Filter was applied with increasing kk to the right.

To make the process of checking the final answer easier, Professor Ibrahim wants students to divide the groups and assign the keys in a way that produces the lexicographically smallest possible array.

Input

The first line of input contains two integers nn and kk (1n1051≤n≤1051k2561≤k≤256), the number of pixels in the image, and the maximum size of a group, respectively.

The second line contains nn integers p1,p2,,pnp1,p2,…,pn (0pi2550≤pi≤255), where pipi is the color of the ii-th pixel.

Output

Print nn space-separated integers; the lexicographically smallest possible array that represents the image after applying the Posterization filter.

Examples
input
Copy
4 3
2 14 3 4
output
Copy
0 12 3 3
input
Copy
5 2
0 2 1 255 254
output
Copy
0 1 1 254 254
Note

One possible way to group colors and assign keys for the first sample:

Color 22 belongs to the group [0,2][0,2], with group key 00.

Color 1414 belongs to the group [12,14][12,14], with group key 1212.

Colors 33 and 44 belong to group [3,5][3,5], with group key 33.

Other groups won't affect the result so they are not listed here.

#include <cstdio>   
#include <iostream> 
#include <algorithm> 
#include <cmath> 
#include <cstdlib> 
#include <cstring> 
#include <vector> 
#include <list> 
#include <map> 
#include <stack> 
#include <queue> 
using namespace std; 
#define ll long long
int f[100005];
int sum[100005];
int n,m;
void set()
{
	for(int i = 0;i <= 260;i++)
	{
		f[i] = i;
		sum[i] = 1;
	}
}
int father(int x)
{
	if(f[x] == x)
		return x;
	else
		return f[x] = father(f[x]);
}
void Union(int x,int y)
{
	int f1 = father(x);
	int f2 = father(y);
	if(f1 != f2)
	{
		f[max(f1,f2)] = min(f1,f2);
		sum[min(f1,f2)]++;
	}
}
int main() 
{
	while(cin >> n >> m)
	{
		set();
		while(n--)
		{
			int x;
			cin >> x;
			while(x - 1 >= 0)
			{
				if(father(x) != x)
					break;
				else if(sum[father(x-1)]+sum[f[x]] > m)
					break;
				else
				{
					sum[father(x-1)]+=sum[f[x]];
					f[x] = father(x-1);
				}
				x--;
			}
			cout << f[x];
			if(n == 0)
				cout << endl;
			else
				cout << " ";
		}
	}
    //cout << "AC" <<endl; 
    return 0; 
} 


大意:在区间[0,255]中,连续的数字分组,每组不多于k个成员,取每组中最小的那个值输出,求总字典序最小的输出

思路:利用并查集,[0,255]的每个值都计数为1

1、如果该值与父节点不相等,则直接输出父节点(因为已经分好组了)

2、如果该值的计数与该值前面元素的父节点计数相加大于m,则直接输出该值(因为这两个联立计数会大于m)

3、如果该值的计数与该值前面元素的父节点计数相加小于等于m,则该值可以与前面元素联立

以下是AC代码:


猜你喜欢

转载自blog.csdn.net/mmmmmmmw/article/details/80248491